import React, { PureComponent, ReactNode } from 'react';
import Pagination from '@vlsergey/react-bootstrap-pagination';
export interface PaginationResult<T> {
    components: ReactNode;
    offset: number;
    page: number;
    pageItems: T[];
    size: number;
}
interface PropsType<T> {
    children: (itemsToRender: PaginationResult<T>) => ReactNode;
    defaultPage?: number;
    defaultSize?: number;
    items: T[];
    pageProps?: React.ComponentProps<typeof Pagination>;
    sizeProps?: {
        options: number[];
    };
}
interface StateType {
    page: number;
    size: number;
}
export default class ArrayPagination<T> extends PureComponent<PropsType<T>, StateType> {
    static defaultProps: {
        defaultPage: number;
        defaultSize: number;
        pageProps: {};
        sizeProps: {
            options: number[];
        };
    };
    constructor(props: PropsType<T>);
    handlePageChange: ({ target: { value } }: {
        target: {
            value: number;
        };
    }) => void;
    handleSizeChange: (event: React.ChangeEvent<HTMLSelectElement>) => void;
    render(): ReactNode;
}
export {};
//# sourceMappingURL=ArrayPagination.d.ts.map