import React, { PureComponent } from 'react';
import Form from 'react-bootstrap/Form';
import Pagination from '@vlsergey/react-bootstrap-pagination';
export default class ArrayPagination extends PureComponent {
    constructor(props) {
        super(props);
        this.handlePageChange = ({ target: { value } }) => {
            this.setState({ page: Number(value) });
        };
        this.handleSizeChange = (event) => {
            const { currentTarget: { value } } = event;
            this.setState({ size: Number(value) });
        };
        this.state = {
            page: this.props.defaultPage,
            size: this.props.defaultSize,
        };
    }
    render() {
        const { children, items, pageProps, sizeProps } = this.props;
        const { page, size } = this.state;
        const offset = size * page;
        const pageItems = items.slice(size * page, size * (page + 1));
        const pagination = React.createElement("div", { style: { display: 'flex' } },
            React.createElement("div", { style: { flexGrow: 2 } },
                React.createElement(Pagination, Object.assign({}, pageProps, { name: "page", onChange: this.handlePageChange, totalPages: Math.ceil(1.0 * items.length / size), value: page }))),
            React.createElement("div", { style: { flexGrow: 1 } },
                React.createElement(Form.Control, { as: "select", name: "size", onChange: this.handleSizeChange, value: size }, sizeProps.options.map(option => React.createElement("option", { key: option, value: option }, String(option))))));
        return children({
            components: pagination,
            pageItems,
            page, offset, size,
        });
    }
}
ArrayPagination.defaultProps = {
    defaultPage: 0,
    defaultSize: 10,
    pageProps: {},
    sizeProps: {
        options: [5, 10, 25, 50, 100, 500, 1000],
    }
};
